# <H1 align="center">Модуль «Усовие»</h1> 

<p> Описываемые в этой части модули сами по себе ничего не делают, их следует использовать вместе с любыми другими. У описываемых модулей (кроме модуля «Break»), помимо привычного «Примечания», есть еще несколько параметров, обязательных для заполнения, но нет отдельного окна с настройками.
<p> Модуль «Условие» позволяет в зависимости от указанного условия выполнять те или иные действия. Условием может быть любое выражение, которое приводится к значению «True» или «False».</p> 

## Интерфейс модуля
<p> Модуль состоит из полей «Примечание» и «Условие». Действия, которые должны выполняться при значении условия «True», добавляются в раздел «THEN», при значении «False» - в раздел «ELSE». Действия добавляются в модуль перетаскиванием их из меню или другого места рабочей области.
<H1 align="center">![Screenshot](img/condition_1.png)</h1> 
<p> Поле «Примечание» предназначено для внесения комментария от разработчика робота. 
<p> Поле «Условие» заполняется по правилам языка программирования C#. Для пользователей, незнакомых с этим языком, предлагается помощь в виде «Конструктора условий», доступная по кнопке справа от условия -![Screenshot](img/condition_2.png). 
## Конструктор условий
<p> Конструктор условий позволяет составлять условия в соответствии с синтаксисом языка C#.
<H1 align="center">![Screenshot](img/condition_3.png)</h1>
### Добавление 
<p> Для того чтобы составить условие, необходимо заполнить оба операнда, выбрать тип операндов (строки или числа), выбрать оператор между ними из предложенного и нажать на кнопку «Добавить»:
<H1 align="center">![Screenshot](img/condition_4.png)</h1>
<H1 align="center">![Screenshot](img/condition_5.png)</h1>
<p> Список операций для строк и для чисел отличается, поэтому сначала выберите тип операндов, а лишь затем операцию.
### Связывание
<p> Несколько условий можно связать с помощью логического «И» либо логического «ИЛИ». 
<p> Делается это следующим образом – удерживая клавишу Shift, выбираются несколько условий, которые должны быть соединены одним оператором, затем нажимается кнопка с соответствующим логическим оператором:
<H1 align="center">![Screenshot](img/condition_6.png)</h1>
<H1 align="center">![Screenshot](img/condition_7.png)</h1>
<p> Символ «||» означает логическое ИЛИ, символ «&&» - логическое И.
### Разъединение
<p> Условия, состоящие из нескольких простых условий, то есть те, которые используют логическое И или ИЛИ, можно разъединить, нажав на соответствующую кнопку. Разъединение происходит по логическим операторам.
<H1 align="center">![Screenshot](img/condition_8.png)</h1>
<H1 align="center">![Screenshot](img/condition_9.png)</h1>
### Сохранение
<p> Для сохранения условия необходимо нажать на кнопку «Сохранить». Получившиеся условие вставится в поле «Условие» условного модуля:
<H1 align="center">![Screenshot](img/condition_10.png)</h1>
<H1 align="center">![Screenshot](img/condition_11.png)</h1>
<p> Законченный модуль может выглядеть следующим образом:
<H1 align="center">![Screenshot](img/condition_12.png)</h1>
### Сворачивание
<p> Для уменьшения занимаемого места в рабочей области проекта, можно свернуть входящие в данный модуль действия по кнопке «Свернуть».
<p> Для удобства использования также можно менять размеры веток «THEN» и «ELSE» вплоть до полного сворачивания одной из них, если та, к примеру, не используется.
<H1 align="center">![Screenshot](img/condition_14.png)</h1>
<H1 align="center">![Screenshot](img/condition_15.png)</h1>
