# <H1 align="center">Модуль «Работа с файлами»</h1> 

<p> Модуль «Работа с файлами» предназначен для изменения расположения файлов, их копирования, архивирования, создания папки и переноса файлов в неё, в общем, для манипуляции с файлами и директориями.</p>

## Интерфейс модуля
<p> Окно модуля объединяет три группы элементов.
<p> Первая группа элементов – это набор полей и кнопок для создания команды. Вторая – непосредственно список команд. И третья – это область предварительного просмотра текстовых файлов.
<H1 align="center">![Screenshot](img/FM_1.png)</h1> 
## Функциональность модуля
### Создание команды
<p> Команда создается следующим образом – выбирается необходимое действие, заполняются остальные поля – нажимается кнопка «Добавить», по которой команда добавляется в «Список команд».  
### Редактирование команды
<p> Для того чтобы отредактировать команду, выделите её в списке команд щелчком левой кнопкой мыши, после чего все поля в левой верхней части окна «Работа с файлами» заполнятся в соответствии с выбранной командой. Измените те поля, которые требуется отредактировать, и, убедившись, что в списке команд все еще выбрано нужное действие, нажмите на кнопку «Редактировать».
### Удаление команды
<p> Для удаления команды необходимо выбрать её в списке команд и нажать на кнопку «Удалить».
### Отключение/включение команды
<p> Созданные команды можно отключать и обратно включать. Отключенные команды не будут выполняться. Сделать это можно, нажав на соответствующую отключаемой команде строку правой кнопкой мыши и выбрав «Отключить/включить».
<H1 align="center">![Screenshot](img/FM_2.png)</h1>
### Выбор файла/папки
<p> Кнопка ![Screenshot](img/FM_3.png) в заполняемых полях открывает стандартный диалог выбора файла или папки, в зависимости от выбранного действия. 
## Перечень и описание действий
### Действие «Сохранить в файл»
<p> Действие перезаписывает существующий текстовый файл, записывая в него строку, указанную в поле «Значение».
<H1 align="center">![Screenshot](img/FM_4.png)</h1>
### Действие «Считать файл»
<p> Действие считывает весь текст из выбранного файла и записывает его в указанную переменную.
<H1 align="center">![Screenshot](img/FM_5.png)</h1>
### Действие «Получить список файлов в папке»
<p> Действие создает переменную-список, в которой лежат пути до каждого файла в папке. 
<H1 align="center">![Screenshot](img/FM_6.png)</h1>
### Действие «Добавить текст в файл»
<p> Действие добавляет текст к уже существующему в файле, не перетирая его данных.
<H1 align="center">![Screenshot](img/FM_6_1.png)</h1>
### Действие «Добавить переход на новую строку»
<p> Действие добавляет символ перехода на новую строку в текст файла.
<H1 align="center">![Screenshot](img/FM_6_2.png)</h1>
### Действие «Переместить файл»
<p> Действие перемещает выбранный файл в указанную папку.
<H1 align="center">![Screenshot](img/FM_7.png)</h1>
### Действие «Переместить папку»
<p> Действие перемещает папку, указанную во втором поле, в директорию, указанную в третьем поле.
<H1 align="center">![Screenshot](img/FM_8.png)</h1>
### Действие «Заархивировать папку»
<p> Действие создает ZIP-архив с указанным именем, добавляя в него содержимое выбранной папки.
<H1 align="center">![Screenshot](img/FM_9.png)</h1>
### Действие «Распаковать архив»
<p> Действие распаковывает ZIP-архив в указанную папку.
<H1 align="center">![Screenshot](img/FM_10.png)</h1>
### Действие «Создать папку»
<p> Действие создает папку с указанным названием в выбранной директории.
<H1 align="center">![Screenshot](img/FM_11.png)</h1>
### Действие «Удалить папку»
<p> Действие удаляет выбранную папку.
<H1 align="center">![Screenshot](img/FM_12.png)</h1>
### Действие «Создать файл txt»
<p> Действие создает новый файл с расширением .txt.
<H1 align="center">![Screenshot](img/FM_13.png)</h1>
### Действие «Удалить файл»
<p> Действие удаляет выбранный файл.
<H1 align="center">![Screenshot](img/FM_14.png)</h1>
### Действие «Скопировать файл»
<p> Действие копирует выбранный файл в указанную директорию. 
<p> В поле «Путь до конечного файла» необходимо ввести путь до папки, в которую файл должен скопироваться, и его название с расширением так, как будто файл уже есть. Новое название может отличаться от исходного.
<H1 align="center">![Screenshot](img/FM_15.png)</h1>
### Действие «Проверить существование файла»
<p> Действие проверяет существование указанного файла и записывает результат в переменную.
<p> «True» - если существует, и иначе «False».
<H1 align="center">![Screenshot](img/FM_16.png)</h1>
### Действие «Проверить существование папки»
<p> Действие проверяет существование указанной папки и записывает результат в переменную.
<p> «True» - если существует, и иначе «False».
<H1 align="center">![Screenshot](img/FM_17.png)</h1>
