# <H1 align="center">Модуль «Считать письма»</h1> 

<p> Модуль «Считать письма» предназначен для получения списка писем с почты для дальнейшей их обработки или просто для скачивания вложений.</p>

## Интерфейс модуля
<p> Модуль состоит из двух вкладок: «Настройки» и «Настройки чтения». 
<p> Вкладка «Настройки» аналогична одноименной вкладке в модуле «Отправить письмо», с одним лишь отличием - в данном модуле предоставляется выбор протокола отправки: IMAP или POP3. При выборе соответствующего протокола и его настроек, поля «Хост», «Порт» и «Использовать SSL» заполняются автоматически (кроме режима «Пользовательские настройки»). 
<H1 align="center">![Screenshot](img/RE_1.png)</h1> 
### Вкладка «Настройки чтения»
<p> Вкладка «Настройки чтения» представляет собой набор полей, которые заполняются в зависимости от того, какие письма следует считать.
<H1 align="center">![Screenshot](img/RE_3.png)</h1> 
<p> Поле «Переменная». В поле ожидается ввод названия переменной, в которую будет внесена информация о считанных письмах. В программе это поле будет представлено списком объектов, имеющих четыре поля: 
<p> 1)	Subject – тема письма;
<p> 2)	Body – тело письма, его основной текст;
<p> 3)	Sender – отправитель;
<p> 4)	Attachments – список путей до скачанных вложений. 
<p> Примеры работы с переменными
<p> •	@mail[1].Attachments[0] – получение пути первого вложения второго считанного письма:
<H1 align="center">![Screenshot](img/RE_4.png)</h1>
<p> •	@mail[0].Subject – получение темы первого скачанного сообщения:
<H1 align="center">![Screenshot](img/RE_5.png)</h1>
<p> Поле «Скачивать вложения в папку» предназначено для ввода пути до папки, в которую загрузятся все вложения считанных писем. Если оставить поле пустым, то файлы будут загружаться во временную директорию компьютера.
<p> Флажок «Только непрочитанные» позволяет настроить считывание только новых писем. Доступно только для протокола IMAP.
<p> Флажок «Отмечать как прочитанные» позволяет после считывания устанавливать пометку о прочтении письма. Доступно только для протокола IMAP.
<p> Поле «Читать из папки» предназначено для настройки конкретной папки в почтовом ящике, из которой следует считывать письма. По умолчанию, письма считываются из папки «Входящие». Доступно только для протокола IMAP.
<p> Поле «Фильтр по теме сообщений» предназначено для настройки фильтра по теме сообщений. Если необходимо скачать письма с темой, содержащей или не содержащей определенную строку, то следует выбрать одноименную операцию в выпадающем списке и вписать нужную строку в появившемся поле:
<H1 align="center">![Screenshot](img/RE_6.png)</h1>
<p> Поле «Фильтр по дате» предназначено для настройки фильтрации считывания писем по дате. При указании значения в данном поле, робот будет считывать только те сообщения, которые удовлетворяют заданному условию. 
<p> Доступны следующие методы фильтрации: 
<p> •	за определенную дату – «На дату»; 
<p> •	начиная с какой-либо даты, включая её – «С даты»;
<p> •	все письма, до какой-либо даты, включая её – «До даты»;
<p> •	«Между датами». 
<p> После выбора метода фильтрации под полем «Фильтр по дате» появится одно или два поля для внесения в них нужных значений в формате ДД.ММ.ГГГГ.
