# <H1 align="center">Модуль «Try/Catch»</h1> 

<p> Данный модуль позволяет обрабатывать ошибки, которые могут возникнуть в процессе выполнения некоторого блока модулей.</p>

##
<H1 align="center">![Screenshot](img/TC_1.png)</h1> 
<p> Модуль состоит из двух блоков – TRY и CATCH. Блок TRY содержит набор модулей или целого робота, который должен выполниться, блок CATCH содержит набор модулей на случай, если произойдет ошибка исполнения модулей блока TRY.
<p> Модуль имеет два текстовых поля, первое – поле «Примечание», в которое можно ввести описание модуля для более удобной навигации по роботу, а второе поле предназначено для сохранения возникшей в модуле TRY ошибки. Так как есть возможность узнать, какая ошибка возникла, каждую возможную ошибку можно корректно обработать в блоке CATCH.
## ПРИМЕР.
<p> Пусть стоит задача – скачать письмо с почты с определенным названием вложения в заранее заданную папку и обработать это вложение модулем Excel, причем в модуле Excel путь до файла будет всегда одинаковым. Например, вложение называется «Отчет за день», путь до папки «C:\Reports», тогда в Excel будет всегда открываться файл «C:\Reports\Отчет за день.xlsx», а вложения с почты всегда будут скачиваться в вышеназванную папку. 
<p> Если письмо с необходимым вложением еще не пришло, то модуль Excel выдаст ошибку «Не удалось открыть документ C:\Reports\Отчет за день.xlsx». В таком случае необходимо как-то обработать эту ошибку, предложить пользователю запустить робота позже, или сказать ему подождать в течение некоторого времени и попробовать снова.
<p> Для обработки ошибки с выводом информационного окна необходимо добавить модуль «Try/Catch», где в блоке TRY будут содержаться модули считывания письма и Excel, а в блоке CATCH модуль «Интерфейс» для вывода пользовательского окна.
<H1 align="center">![Screenshot](img/TC_2.png)</h1> 
<p> В результате работы такого робота будет либо стандартное сообщение «Скрипт отработал успешно!», если письмо было на почте, либо окно с текстом «Письмо еще не пришло» в ином случае. В переменной @error будет содержаться текст «Не удалось открыть документ C:\Reports\Отчет за день.xlsx».
<H1 align="center">![Screenshot](img/TC_3.png)</h1> 