# <H1 align="center">Модуль «Word»</h1> 

<p> Модуль Word обеспечивает работу с документами Microsoft Word пакета Microsoft Office. С помощью модуля можно создавать и редактировать документы с популярными текстовыми расширениями, такими как .doc, .docx, .html.</p>

## Интерфейс окна
<p> Окно модуля состоит из трех основных частей, первая – часть, содержащая в себе поля для создания команд и кнопок управления ими, вторая – таблица «Список команд», которая будет содержать все добавленные действия для работы с файлом, и третья – окно с предварительным просмотром загруженного файла. </p>
<H1 align="center">![Screenshot](img/word_1.png)</h1> 
<p> Окно предварительного просмотра позволяет просмотреть весь загруженный документ в том же виде, в котором он виден в самом Microsoft Word. 
<p> Раздел настройки модуля состоит из нескольких полей, доступность которых варьируется от необходимых для работы действий. Три первых поля являются основными и доступными всегда, причем обязательными являются только два из них:
<p> •	«Путь к файлу» - поле с кнопкой, открывающей диалог выбора файла. Данное поле предназначено для выбора существующего файла, с которым предстоит далее работать, либо для введения в него пути, по которому необходимо будет создать новый файл. Обязательное поле;
<p> •	«Действие» - выпадающий список, состоящий из действий, которые можно применить к загруженному файлу или создать новый с указанным путем в поле «Путь к файлу». Обязательное поле;
<H1 align="center">![Screenshot](img/word_2.png)</h1> 
<p> •	«Описание» - поле, необходимое для удобной навигации по действиям, заполняется комментарием разработчика о создаваемом действии. Необязательное поле.
<p> Все возможные действия будут описаны в следующей главе.
<p> Для добавления действия в таблицу «Список команд» необходимо воспользоваться кнопкой «Добавить» под полями настройки действия.
<H1 align="center">![Screenshot](img/word_3.png)</h1> 
<p> После нажатия на кнопку созданное действие добавится в «Список команд». Для редактирования существующей команды или её удаления, необходимо выбрать строку с командой в таблице команд и нажать «Удалить» для её удаления, или отредактировать необходимые поля действия и затем нажать «Редактировать».
<p> Для того, чтобы поменять существующие действия местами, необходимо выбрать одно действие и нажать на необходимые кнопки «Поднять» или «Опустить», которые расположены в правом углу над таблицей с командами.
<H1 align="center">![Screenshot](img/word_4.png)</h1>
## Действия модуля
### Создать файл
<p> Данное действие создает файл с указанным путем, именем и расширением. Для настройки действия необходимо заполнить поле «Путь к файлу» строкой типа «Путь до файла/Название файла.требуемое расширение», например «C:/Reports/Documents/Test.docx».
<H1 align="center">![Screenshot](img/word_5.png)</h1>
### Получить текст
<p> Действие «Получить текст» позволяет считать весь текст из загруженного файла в переменную. Для настройки действия появляется еще одно поле помимо стандартных трёх – «Переменная», в которую записывается название переменной (с символа «@»), в которую будет записан считанный текст.
<H1 align="center">![Screenshot](img/word_6.png)</h1>
### Записать текст
<p> С помощью действия можно записать имеющийся текст, например, считанный из другого текстового файла, в текущий загруженный файл. Для настройки обязательно заполнение поля «Значение», куда вводится либо переменная (с символа «@»), содержащая текст, либо сам текст. Обратите внимание, что текст, введенный данным действием, полностью затрет существующий текст в файле.
<H1 align="center">![Screenshot](img/word_7.png)</h1>
### Добавить текст
Данное действие позволяет добавлять текст к существующему с применением необходимого форматирования. Для редактирования открываются все поля модуля. Далее будет подробно описано каждое поле, отличное от основных трёх.
«После символа №» - данное поле ожидает ввод целого числа, обозначающего, после какого по счету символа необходимо вставить текст (с учетом пробелом и символов переноса строки или разрыва страницы).
<H1 align="center">![Screenshot](img/word_8.png)</h1>
<p> «Размер текста» - аналогичен полю «Размер шрифта» в Microsoft Word – устанавливает размер добавляемого текста. Ожидается ввод целого или десятичного числа.
<p> «Шрифт» - выпадающий список, содержащий в себе набор стандартных шрифтов пакета Micrisift Office – устанавливает шрифт добавляемого текста.
<p> «Цвет текста» и «Цвет фона» – поля с иконкой палетки сбоку, по нажатию на которые открывается диалог выбора цвета – устанавливают цвет добавляемого текста и его фона соответственно. Вводится в формате цвета HEX – шестнадцатеричное представление RGB (без символа # в начале).
<p> «Текст» - поле, в которое указывается добавляемый текст или переменная, которая его содержит.
### Добавить перенос строки
<p> Данное действие добавляет символ переноса строки в файл. Не требует заполнения дополнительных полей.
<H1 align="center">![Screenshot](img/word_9.png)</h1>
### Удалить текст
<p> С помощью данного действия можно удалить текст, зная количество символов в нем и его расположение. Для настройки необходимо ввести в поле «После символа №, количество» два целых числа через запятую, где первое число – номер символа, после которого необходимо удалить текст, а второе – количество символов в удаляемом тексте.
<H1 align="center">![Screenshot](img/word_10.png)</h1>
### Экспорт
<p> С помощью данного действия можно менять расширение загруженного файла. Для настройки действия нужно выбрать из выпадающего списка «Тип» тип файла, в который нужно экспортировать, и указать путь с названием и расширением будущего файла в поле «Путь выходного файла».
<H1 align="center">![Screenshot](img/word_11.png)</h1>