# <H1 align="center">Модуль «Кликер»</h1> 

<p>	Модуль «Кликер» предназначен для записи последовательности действий, выполняемых пользователем, а именно кликов по определенным местам экрана и нажатий кнопок на клавиатуре или мыши. С помощью этого модуля можно производить интеграции между самыми разными программами, так как он точно имитирует действия пользователя, то есть, если вы сможете это сделать, то это сможет сделать и «Кликер».</p>
<p>	Использование роботов-кликеров рекомендуется на компьютерах с таким же разрешением, как и тот, на котором был написан данный робот.</p>

## Создание макроса
<p>При открытии модуля «Кликер» появится диалоговое окно «Запись действий макроса», состоящее из трех элементов – кнопки «Начать запись», области, в которой будут отображены записанные действия, и кнопки «Сохранить».</p>
<H1 align="center">![Screenshot](img/clicker_1.png)</h1> 
<p>По нажатию кнопки «Начать запись» программа переходит в режим ожидания нажатия кнопки «TAB», по которой открывается окно создания действия (команды).</p>
<H1 align="center">![Screenshot](img/clicker_2.png)</h1> 
<p>В открывшемся окне происходит настройка действия (описание всех возможных действий будет дано ниже). По завершению создания команды и нажатию кнопки сохранить, новое действие будет добавлено в макрос.</p>
<H1 align="center">![Screenshot](img/clicker_3.png)</h1> 
<p>Изменить положение действия в списке команд можно с помощью кнопок с изображением стрелок, расположенных в правой части блока.</p>
<H1 align="center">![Screenshot](img/clicker_4.png)</h1> 
<p>Кнопка с изображением крестика, расположенная между стрелками, предназначена для удаления действия из списка команд.</p>
<p>Для сохранения макроса необходимо нажать на кнопку «Сохранить».</p>
## Создание команды
<p>Окно создания команды состоит из статичных и изменяющихся полей. Статичными являются такие поля, как «Действие», «Пауза» и «Примечание».</p>
## Статичные поля
### Действие
<p>Поле «Действие» состоит из перечня доступных действий для записи макроса – нажатие кнопок мыши и клавиатуры, наиболее часто встречающиеся сочетания кнопок (скопировать, вставить). Далее будут приведены все действия, доступные в модуле.</p>
### Пауза
<p>Поле «Пауза» предназначено для создания эффекта ожидания после выполняемой команды. Значение указывается в миллисекундах.</p>
<p>Например, после нажатия на иконку браузера роботу следует подождать несколько секунд, пока браузер запустится и будет готов к работе – в данном примере в команде открытия браузера (кликнуть мышкой по его иконке) в поле «Пауза» следует написать некоторое значение, например, 5000, т.е. 5 секунд. </p>
### Примечание
<p>Поле «Примечание» позволяет писать комментарии, чтобы не запутаться в командах.</p>
## Поля, появляющиеся только при определенных действиях
### Переключатели «Изображение» и «Координаты»
<p>При создании действий, связанных с кликом мыши, вам предлагается выбрать, куда кликать – по определенным координатам или по изображению. Если программа, с которой вы работаете, статичная и не меняет расположение своих кнопок, то можно воспользоваться кликом по координатам. Тогда возникает вопрос, как рассчитать координаты? Все очень просто – при нажатии кнопки «TAB» нужно располагать мышь ровно в том месте, куда следует нажать. В диалоговом окне создания команды координаты уже будут заполнены.</p>
<p>Если программа может менять расположение её элементов, то настоятельно рекомендуем использовать клик по изображению. Для этого нажмите на переключатель «Изображение».</p>
<H1 align="center">![Screenshot](img/clicker_5.png)</h1> 
<p>При изменении переключателя изменится нижняя часть окна – появятся кнопки «Выбрать изображение», «Выделить изображение» и поле для ввода «Процент совпадения». 
<p>Изображение, по которому потребуется кликнуть для выполнения действия, можно настроить двумя способами:
<p>1) загрузить имеющееся изображение, нажав на кнопку «Выбрать изображение»
<p>2) выбрать фрагмент снимка окна, в котором будет воспроизводиться действие, с помощью кнопки «Выделить изображение». После нажатия на кнопку студия сделает снимок экрана и предложит вам выбрать фрагмент получившегося изображения.
<p>При использовании клика по изображению, обратите внимание на то, что, если на экране таких изображений будет несколько, действие будет применено к первому найденному!
<p>Поле «Процент совпадения» необходимо для случаев, когда искомое изображение может немного отличаться от того, что может быть в реальности (например, наличие выделения вокруг кнопки, если она выбиралась ранее, и отсутствие такого выделения). В подобных случаях уменьшайте процент совпадения до тех пор, пока изображение не будет находиться и в том, и в другом случае. Однако если процент совпадения уменьшить слишком сильно, модуль может найти то, что не планировали искать.
Поля «Количество попыток» и «Пауза между ошибками» предназначены для случаев, когда программа не смогла найти заданное ей изображение. Вы можете указать, сколько раз следует пытаться искать требуемое изображение и сколько секунд ждать между попытками. Например, после запуска браузера нужно нажать на кнопку с иконкой «Плюсик» – создание новой вкладки. Если браузер будет загружаться слишком долго, больше 5-ти секунд (это время указано в паузе команды открытия браузера), тогда программа начнёт искать «плюсик», которого еще нет. Затем программа подождет указанное ей количество секунд между попытками и попробует снова. Как только изображение будет найдено, программа подождет то количество секунд, которое указано в поле «Пауза» данной команды, и перейдет к следующей.
### Прокрутка мыши
Данное поле появляется при действии «Прокрутка мыши». В него вводится значение в пикселях, на сколько необходимо прокрутить колесико мыши. Если прокрутка вверх, то значение должно быть положительным, если вниз, то отрицательным.
Во всех полях окна создания команды возможно использование переменных.
## Описание действий, доступных в модуле
### Действие «Кликнуть мышкой» 
Основное действие модуля – нажатие левой кнопкой мыши по указанным координатам или изображению.
### Действие «Кликнуть мышкой дважды»
Двойной клик по указанным координатам или изображению, например, для открытия приложения с рабочего стола.
### Действие «Кликнуть правой кнопкой мыши»
Клик правой кнопкой мыши, например, по приложению на рабочем столе, чтобы открыть его контекстное меню.
### Действие «Кликнуть колесиком мыши»
В некоторых программах есть возможность использовать клик колесика мыши для исполнения некоторых действий, например, закрыть вкладку в браузере.
### Действие «Прокрутка мыши»
Прокрутка колесом мыши вниз или вверх по странице. Здесь координаты играют роль того, где будет находиться курсор при прокрутке колеса, так как ползунков на экране может быть несколько. Для прокрутки экрана вниз в поле «Прокрутка мыши» должно быть введено отрицательное значение (-150), вверх - положительное (150).
### Действие «Ввести текст»
<p>Данное действие вводит текст, который записан в поле «Текст». Поле, куда вводится текст, должно быть выделено (должен быть фокус, стоять каретка). 
<p>В некоторых программах необходим специфичный ввод текста – в конкретной кодировке. В подобных случаях следует выбрать кодировку из предложенных в выпадающем списке «Использовать кодировку», или указать свою. Текст может лежать в переменной и быть скопированным из какой-либо программы, использующей конкретную кодировку. В таком случае, при вставке скопированного текста в другую программу, необходимо сначала считать его в кодировке исходной программы. Кодировка исходной программы вводится или выбирается в поле «Начальная кодировка». Заполнение этих полей необязательно.
<p>Флажок «Использовать WinInput» позволяет включить режим более корректного и быстрого ввода текста, но он может не поддерживаться некоторыми программами. Его использование необязательно.
<p>Пример заполнения действия: 
<H1 align="center">![Screenshot](img/clicker_6.png)</h1> 
### Действие «Нажать кнопку»
<p>Имитирует нажатие клавиши клавиатуры. Необходимую клавишу следует выбрать в выпадающем списке «Кнопка». В списке предложены все возможные клавиши, которые могут присутствовать как на простых, так и на расширенных клавиатурах (изменение громкости звука, запуск/остановка музыки и другие нестандартные кнопки).
<H1 align="center">![Screenshot](img/clicker_7.png)</h1> 
### Действие «Нажать две кнопки»
<p>Имитирует нажатие сочетания двух клавиш клавиатуры, например CTRL+A – выделение всего текста в поле. Необходимые кнопки выбираются в двух выпадающих списках «Кнопка». Список кнопок тот же, что и в действии «Нажать кнопку».
<H1 align="center">![Screenshot](img/clicker_8.png)</h1> 
### Действие «Скопировать»
<p>Имитирует нажатие сочетания клавиш клавиатуры CTRL+C. Копирует выделенное заранее значение в буфер обмена и записывает его, при необходимости, в переменную, указанную в поле «Записать в». Данное поле не обязательно к заполнению. Ввод переменной начинается с символа «@».
<H1 align="center">![Screenshot](img/clicker_9.png)</h1>
### Действие «Вставить»
<p>Имитирует нажатие сочетания клавиш клавиатуры CTRL+V. Вставляет в выбранное поле значение из буфера обмена. 
