# <H1 align="center">Модуль «Excel»</h1> 

<p> Модуль «Excel» является самым обширным модулем в программе. Данный модуль предназначен для обработки Excel-файлов в фоновом режиме, незаметном для пользователя компьютера. Модуль последовательно выполнит заданный ему список команд.</p>

## Интерфейс модуля
<p> Окно модуля состоит из нескольких разделов: «Добавить команду», «Общие настройки», «Список команд» и окно с предварительным просмотром файла.</p>
<H1 align="center">![Screenshot](img/excel_1.png)</h1> 
<p> Окно предварительного просмотра позволяет просматривать все листы загруженного файла с помощью вкладок с названиями листов и полосы прокрутки. Также есть возможность вписывать в ячейки свои значения, применять различное форматирование, но эти изменения сохранены не будут, то есть данный функционал доступен только для «примерки».</p>
<H1 align="center">![Screenshot](img/excel_2.png)</h1> 
## Раздел «Общие настройки»
### Загрузить файл
<p> Раздел «Общие настройки» состоит из поля «Имя файла» и кнопок «Загрузить файл» и «Выбрать ячейку».</p> 
<p> Работу с модулем Excel советуем начинать с выбора рабочего файла. После того, как по кнопке «Загрузить файл» будет выбран файл, необходимо подождать несколько секунд и указанный файл будет отображен в окне предварительного просмотра.</p>
<H1 align="center">![Screenshot](img/excel_3.png)</h1> 
## Разделы «Добавить команду» и «Список команд»
<p> Раздел «Добавить команду» является основным «полотном» данного модуля. В нем создаются действия, имитирующие работу пользователя, например, такие как считать некоторый диапазон ячеек, затем перенести его на другой лист, удалить дубликаты и построить круговую диаграмму. В данном случае было описано 4 действия. Эти 4 действия необходимо последовательно выбирать и добавлять в раздел «Список команд» - таблицу, отображающую все действия, которые будут выполняться данным модулем. Набор полей в данном разделе не всегда одинаков – он меняется в зависимости от выбранного действия в первом поле.</p> 
<p> Кнопки «Добавить», «Редактировать» и «Удалить» предназначены для работы с разделами «Добавить команду» и «Список команд».</p> 
### Добавление команды
<p> Для добавления команды предусмотрена кнопка «Добавить». Она заносит созданное действие в таблицу «Список команд».</p> 
<H1 align="center">![Screenshot](img/excel_4.png)</h1> 
<p> При выборе строки в списке команд информация по выбранному действию отобразится в разделе «Добавить команду».</p> 
<p> Помимо описанного функционала, кнопка «Добавить» служит для копирования уже имеющихся действий в списке команд. Для этого необходимо выбрать строку в списке команд и нажать на кнопку «Добавить». Таким образом, если нужно выполнить действие несколько раз, достаточно его копировать, а не создавать вновь.</p> 
<H1 align="center">![Screenshot](img/excel_5.png)</h1> 
### Редактирование команды
<p> Для редактирования команды предусмотрена кнопка «Редактировать». Чтобы изменить команду, выделите ее в списке команд, внесите необходимые изменения в разделе «Добавить команду» и нажмите на кнопку «Редактировать» для сохранения изменений.</p> 
### Изменение порядка действий
<p> Для изменения порядка действий предусмотрены кнопки с иконками стрелок «Вверх» и «Вниз». Кнопки расположены справа от списка команд.</p>  
<p> Изменение порядка действий бывает необходимо, когда требуется добавить действие, которое не предусмотрели сразу и не внесли в список команд. В таком случае вы можете добавить действие стандартным способом, а затем переместить его.</p> 
<H1 align="center">![Screenshot](img/excel_6.png)</h1> 
<H1 align="center">![Screenshot](img/excel_7.png)</h1> 
### Удаление команды
<p> Кнопка «Удалить» удаляет выбранную строку из списка команд.</p>
### Отключение команды
<p> Если вы не хотите удалять команду, так как хотели бы, например, проверить, как работает робот без неё, а затем вернуть её в работу, то можно отключить команду, нажав на соответствующую ей строку правой кнопкой мыши и отключить или, наоборот, включить её.</p>
<H1 align="center">![Screenshot](img/excel_8.png)</h1>
### Выбор ячейки
<p> Кнопка «Выбрать ячейку» работает для каждого действия по-своему, но смысл у неё один – она заполняет поле «Ячейки» или «Диапазон» (в зависимости от того, какое из них используется в выбранном действии) названием выбранной в окне предварительного просмотра ячейки / диапазона и вписывает в поле «Лист» название листа, на котором находятся выбранные ячейки. В некоторых действиях по кнопке заполняется только одна ячейка, хотя был выбран диапазон – это означает, что в данном действии использование диапазона невозможно.</p>
<H1 align="center">![Screenshot](img/excel_9.png)</h1>
<H1 align="center">![Screenshot](img/excel_10.png)</h1>
<p> В некоторых действиях кнопка «Выбрать ячейку» заполняет номера колонок, строк, какие-либо значения. При работе с файлами рекомендуется её использование для минимизации возникновения синтаксических ошибок.</p>
### Сохранение команды
<p> Для сохранения команды в модуле Excel нажмите на кнопку «Сохранить» в правом нижнем углу модуля.</p>
<H1 align="center">![Screenshot](img/excel_11.png)</h1>
## Описание действий, доступных в модуле
<p> Действия разделены на группы для удобной навигации по выпадающему списку. Если вы знаете точное название действия, то вы можете начать вводить его в поле «Действие», и программа постарается подсказать вам то действие, которое вы ищите.
### Группа «Работа с данными»
#### Действие «Считать данные»
<p> Данное действие позволяет считать значение из одной конкретной ячейки, либо из диапазона ячеек. Если будет указана одна ячейка, то создастся переменная с типом «Элемент», если же диапазон, то будет создана переменная с типом «Таблица».
<H1 align="center">![Screenshot](img/excel_12.png)</h1>
#### Действие «Записать данные»
<p> Действие позволяет записать указанное значение в одну или в диапазон ячеек.
<H1 align="center">![Screenshot](img/excel_13.png)</h1>
#### Действие «Формула»
<p> Действие позволяет записать формулу в указанную ячейку (или в диапазон) и вернуть её результат в указанную переменную. Поле «Переменная» можно оставить пустым, если результат выполнения данной формулы не важен.
<H1 align="center">![Screenshot](img/excel_14.png)</h1>
#### Действие «Получить формулу»
<p> Действие возвращает формулу из ячейки в указанную переменную.
<H1 align="center">![Screenshot](img/excel_15.png)</h1>
#### Действие «Заменить формулу на её значение»
<p> Данное действие заменяет формулу в ячейке или диапазоне ячеек на её результат.
<H1 align="center">![Screenshot](img/excel_16.png)</h1>
### Группа «Работа со строками»
#### Действие «Добавить строку»
<p> Действие вставляет новую строку в указанное место.
<H1 align="center">![Screenshot](img/excel_17.png)</h1>
#### Действие «Удалить строку»
<p> Действие удаляет указанную строку.
<H1 align="center">![Screenshot](img/excel_18.png)</h1>
#### Действие «Получить количество строк»
<p> Действие возвращает номер последней используемой строки в листе в указанную переменную.
<H1 align="center">![Screenshot](img/excel_19.png)</h1>
#### Действие «Получить количество отфильтрованных строк»
<p> Действие возвращает количество видимых строк при примененном фильтре в указанную переменную.
<H1 align="center">![Screenshot](img/excel_20.png)</h1>
### Группа «Работа с колонками»
#### Действие «Добавить столбец»
<p> Действие добавляет новый столбец в указанное место.
<H1 align="center">![Screenshot](img/excel_21.png)</h1>
#### Действие «Удалить столбец»
<p> Действие удаляет указанный столбец.
<H1 align="center">![Screenshot](img/excel_22.png)</h1>
#### Действие «Получить количество столбцов»
<p> Действие возвращает номер самого последнего используемого столбца.
<H1 align="center">![Screenshot](img/excel_23.png)</h1>
### Группа «Работа с листами и файлами»
#### Действие «Создать новый лист»
<p> Действие создает новый лист с указанным именем.
<H1 align="center">![Screenshot](img/excel_24.png)</h1>
#### Действие «Удалить лист»
<p> Действие удаляет лист с указанным именем.
<H1 align="center">![Screenshot](img/excel_25.png)</h1>
#### Действие «Очистить лист»
<p> Действие очищает ячейки листа от данных. Не очищает форматирование!
<H1 align="center">![Screenshot](img/excel_26.png)</h1>
#### Действие «Получить список листов»
<p> Возвращает переменную-список, содержащую названия всех листов файла.
<H1 align="center">![Screenshot](img/excel_26_1.png)</h1>
#### Действие «Создать новый файл»
<p> Действие создает в указанной папке новый файл с названием и указанным расширением (если расширение не указано, создается файл .xlsx). Если поле «Лист» заполнено, то первый лист файла будет назван так, как указано в поле, иначе - по умолчанию (Лист 1, Sheet 1, в зависимости от языка системы).
<H1 align="center">![Screenshot](img/excel_27.png)</h1>
#### Действие «Заполнить лист на основе Excel-файла»
<p> Данное действие производит заполнение листа текущего файла по аналогии с листом какого-либо другого файла. В поле «Лист» указывается лист текущего файла.
<H1 align="center">![Screenshot](img/excel_28.png)</h1>
#### Действие «Экспортировать в PDF»
<p> Действие позволяет сохранить Excel-файл в формате PDF стандартными методами Windows, то есть деление листа Excel-файла на листы в документе PDF будет производиться по стандартным настройкам, указанным в файле Excel (по умолчанию размер листа А4, с обычными полями).
<H1 align="center">![Screenshot](img/excel_29.png)</h1>
<p>Название файла и его расположение будут совпадать с экспортируемым файлом.
### Группа «Поиск»
#### Действие «Найти данные»
<p> Ищет заданную строку в указанном листе и возвращает адрес первой найденной ячейки.
<H1 align="center">![Screenshot](img/excel_30.png)</h1>
#### Действие «Поиск строки по значениям колонок»
<p> Данное действие ищет и возвращает номер первой найденной строки, в заданных колонках которой записаны указанные значения.
<H1 align="center">![Screenshot](img/excel_31.png)</h1>
<p> В данном случае будет искаться строка, в колонке A которой 23.03.2020, а в колонке B – Уфа.
#### Действие «Найти лист»
<p> Ищет лист, в котором есть ячейка с указанным в поле «Строка» значением и возвращает его название в указанную переменную.
<H1 align="center">![Screenshot](img/excel_32.png)</h1>
### Группа «Другие функции»
#### Действие «Сместить ячейку»
<p> Смещает заданную ячейку на указанное количество строк и колонок, затем возвращает результат в переменную (в данном примере результатом будет ячейка D13).
<H1 align="center">![Screenshot](img/excel_33.png)</h1>
#### Действие «Наложить фильтр»
<p> Данное действие добавляет фильтр в таблицу на указанном листе, ячейка из которой указана в поле «Ячейка из диапазона значений». В поле столбец записывается столбец, к которому необходимо применить фильтр. Фильтруемый столбец должен быть один. Если необходимо применить несколько фильтров к одной таблице, то необходимо добавить для каждого фильтра свое действие в рамках одного Excel-модуля. Функция, по которой должно происходить сравнение, выбирается из выпадающего списка в поле «Функция», значение, с которым будет происходить сравнение при фильтрации, указано в поле «Значение».
<H1 align="center">![Screenshot](img/excel_34.png)</h1>
#### Действие «Удалить фильтр»
<p> Действие удаляет все фильтры с листа.
<H1 align="center">![Screenshot](img/excel_35.png)</h1>
#### Действие «Добавить сортировку»
<p> Действие добавляет сортировку к указанному диапазону по выбранному столбцу. В зависимости от флажка определяется, сортируется столбец по убыванию или по возрастанию. Столбец для сортировки должен быть один.
<H1 align="center">![Screenshot](img/excel_36.png)</h1>
#### Действие «Очистить диапазон»
<p> Действие удаляет все значения и форматирования ячеек в указанном диапазоне.
<H1 align="center">![Screenshot](img/excel_37.png)</h1>
#### Действие «Получить уникальные значения столбца»
<p> Аналогично действию «Удалить дубликаты» в Excel, данное действие возвращает только уникальные значения указанных столбцов из диапазона. Итоговая таблица может быть вставлена как в тот же лист, так и в другой в лист, но в тот же диапазон. В зависимости от наличия дубликатов, количество строк может быть уменьшено.
<H1 align="center">![Screenshot](img/excel_38.png)</h1>
#### Действие «Промежуточные итоги»
<p> Действие добавляет операцию Excel «Промежуточные итоги» на указанный лист к указанному диапазону.
<H1 align="center">![Screenshot](img/excel_39.png)</h1>
<p> Поле «Для колонок» соответствует полю в Excel «Добавить итоги по» (выделено зеленым), поле «При каждом изменении в колонке» соответствует аналогичному полю в Excel, но должно быть заполнено названием колонки Excel (A, B, … или 1, 2, …) (выделено красным), поле «Функция» заполняется операцией, которая должна быть применена для выбранных колонок (выделено синим).
<H1 align="center">![Screenshot](img/excel_40.png)</h1>
#### Действие «Сводная таблица»
<p> Добавляет сводную таблицу в указанные лист и диапазон (поле «Лист, диапазон для вставки) на основе данных таблицы из поля «Лист, диапазон источника».
<H1 align="center">![Screenshot](img/excel_41.png)</h1>
<p> В поля «Поля в столбцах», «Поля в значениях» и «Поля в строках» вписываются названия колонок таблицы-источника (а не Excel-таблицы), как в программе Excel:
<p> «Поля в столбцах» соответствуют названиям столбцов таблицы, значения которых должны быть расположены в столбцах сводной таблицы (выделено зеленым);
<p> «Поля в значениях» соответствуют названиям столбцов таблицы, значения которых должны быть расположены в значениях сводной таблицы (выделено красным);
<p> «Поля в строках» соответствуют названиям столбцов таблицы, значения которых должны быть расположены в строках сводной таблицы (выделено синим);
<H1 align="center">![Screenshot](img/excel_42.png)</h1>
#### Действие «Скопировать и вставить ячейку/диапазон»
<p> Данное действие позволяет скопировать данные и форматирование и вставить их в тот же или в другой файл. С помощью него можно «растягивать» формулы (см. «Действие «Формула»).
<H1 align="center">![Screenshot](img/excel_43.png)</h1>
#### Действие «Отобразить в виде процентов»
<p> Действие переводит выбранный диапазон в проценты.
<H1 align="center">![Screenshot](img/excel_44.png)</h1>
#### Действие «Круговая диаграмма»
Действие создает на указанном листе круговую диаграмму. Значения диаграммы берутся из диапазона, указанного в поле «Ячейки», диапазон с названиями значений указывается в поле «Диапазон названий». В поле «Расположение» указываются границы расположения круговой диаграммы, а именно левый верхний угол и правый нижний через запятую.
<H1 align="center">![Screenshot](img/excel_45.png)</h1>
#### Действие «График»
<p> Действие создает линейный график с одним или несколькими рядами. Ряд необходимо указать в поле «Диапазон значений» в виде одномерного диапазона (по одной колонке или по одной строке). Если рядов больше, чем один, то последующие ряды нужно указать в таком же виде через «;». Диапазон аргументов должен быть один и указывается аналогично ряду. «Ячейки с названиями рядов» заполняются названиями ячеек через «;», их количество должно быть равно количеству рядов, первая ячейка отображает название первого ряда и т.д. В ячейку для вставки записывается ячейка, в которой будет располагаться левый верхний угол графика.
<H1 align="center">![Screenshot](img/excel_46.png)</h1>
#### Действие «Проверка значений»
<p> Действие создает ограничение типов данных, которые можно ввести в выбранные ячейки, путем выбора предложенных правил. В поле «Лист» вводится лист, в ячейки которого добавляются ограничения, в поле «Ячейки» вводится диапазон ячеек, на которых будет проводиться проверка значений при вводе. В поле «Тип данных» выбирается один из предложенных типов данных – целое или действительное число, список, дата, длина текста, время. Поле «Операция» состоит из списка доступных операций для составления правила проверки – равно, не равно, больше, меньше, больше или равно, меньше или равно, между и вне. При использовании типа данных «Список» заполнение поля «Операция» не требуется, поэтому оно не доступно для редактирования. 
<p> Последнее поле меняется в зависимости от типа данных – для типа «Список» это будет «Источник данных», для всех остальных – «Критерии (ч/з ;)». Поле «Источник данных» заполняется диапазоном значений (внутри одного столбца или одной строки), в которой будет указан в списке (если список статичный, то указывайте абсолютную ссылку). Поле «Критерии (ч/з ;)» заполняется значениями, относительно которых будет применяться правило проверки.
<p> Поле «Сообщение об ошибке» заполняется текстом ошибки, которая будет отображаться, если в ячейку введено значение, не удовлетворяющее заданному для неё правилу. Является необязательным полем. Если оставить его пустым, то будет отображаться ошибка «Введенное значение неверно. Набор значений, которые могут быть введены в ячейку, ограничен».
<H1 align="center">![Screenshot](img/excel_47.png)</h1>
### Группа «Форматирование»
#### Действие «Условное форматирование»
<p> Действие форматирует указанные ячейки на выбранном листе в зависимости от того, удовлетворяют ли они указанному условию. В поле «Лист, диапазон» через запятую вводятся лист и диапазон или одна ячейка из этого листа, к которым будет применяться условное форматирование. В полях «Цвет заливки» и «Цвет текста» указываются цвета, которыми будет залита ячейка и окрашен текст в ней, если она будет удовлетворять условию. Условие составляется из выбора функции и указания значения для сравнения. Доступные функции – равно, не равно, больше, меньше, больно или равно, меньше или равно, формула. Если выбрана функция «формула», то в поле «Значение для сравнение» следует вписать формулу в формате Excel, начиная со знака «=».
<H1 align="center">![Screenshot](img/excel_48.png)</h1>
#### Действие «Цвет ячейки/диапазона»
<p> Действие меняет цвет заливки текста и самого текста в указанном диапазоне / ячейке.
<H1 align="center">![Screenshot](img/excel_49.png)</h1>
#### Действие «Ширина столбца(-ов)»
<p> Действие изменяет ширину указанных столбцов. Столбцы можно перечислять через запятую, писать их номера вместо названий (с 1-цы). Ширина указывается в той же единице измерения, которая используется в Excel.
<H1 align="center">![Screenshot](img/excel_50.png)</h1>
#### Действие «Высота строки (-ок)»
<p> Действие изменяет высоту указанных строк. Используется та же единица измерения, что и в Excel.
<H1 align="center">![Screenshot](img/excel_51.png)</h1>
#### Действие «Объединить ячейки»
<p> Действие объединяет указанные ячейки на выбранном листе. В модуле предусмотрено три вида объединений: 
<p> •	простое объединение – то есть объединяются и колонки, и столбцы диапазона;
<p> •	объединение по строкам;
<p> •	объединение по столбцам.
<H1 align="center">![Screenshot](img/excel_52.png)</h1>
#### Действие «Очистить форматирование»
<p> Действие очищает форматирование в указанном диапазоне выбранного листа.
<H1 align="center">![Screenshot](img/excel_53.png)</h1>
#### Действие «Формат ячейки»
<p> Действие меняет формат указанной ячейки на выбранный. По умолчанию, все значения, заносимые в Excel студией, имеют строковый формат, поэтому, для корректного пересчета формул или сортировки, необходимо привести данные к нужному формату.
<H1 align="center">![Screenshot](img/excel_54.png)</h1>
#### Действие «Формат числа»
<p> Действие отображает число по определенным правилам числового формата Excel.
<H1 align="center">![Screenshot](imgexcel_55/.png)</h1>
<p> Примеры форматов можно посмотреть в программе Excel, кликнув правой кнопкой левой кнопкой мыши по ячейке – «Формат ячейки» – вкладка «Число» - (все форматы): 
<H1 align="center">![Screenshot](img/excel_56.png)</h1>
<p> Наиболее часто используемые форматы числа предлагаются в студии при наведении на поле для ввода формата.
<H1 align="center">![Screenshot](img/excel_57.png)</h1>
#### Действие «Выравнивание»
<p> Действие применяет заданное выравнивание в указанных ячейках. В поле «Общее положение» предлагается выбрать одно из двух – по вертикали или по горизонтали применять выравнивание, выбранное в поле «Выравнивание содержимого», которое, в свою очередь, предлагает выбрать выравнивание содержимого по левому/правому краю, либо по верхнему/нижнему краю, либо по центру.
<H1 align="center">![Screenshot](img/excel_58.png)</h1>
#### Действие «Шрифт»
<p> Действие меняет шрифт, стиль или размер выбранных ячеек на указанном листе. Модуль предоставляет выбор всех стандартных шрифтов, доступных в пакете Microsoft Office.
<H1 align="center">![Screenshot](img/excel_59.png)</h1>
#### Действие «Границы»
<p> Действие добавляет или изменяет границы выбранных ячеек на указанном листе. Предполагает настройку расположения границ – внешние, внутренние, только правая и др., цвет границ и их стиль – толстая, тонкая, штриховая линия и др.
<H1 align="center">![Screenshot](img/excel_60.png)</h1>

